Randomize Timer

#include "Hangman_1_GRX.bas"
#include "Hangman_2_GRX.bas"
#include "Hangman_3_GRX.bas"
#include "Hangman_4_GRX.bas"
#include "Hangman_5_GRX.bas"
#include "Hangman_6_GRX.bas"

Type gmlLIST
    gmlWORD  as ZSTRING PTR
    gmlWLEN  as Integer
    NextWord as gmlLIST ptr
End Type

Type gmlQUEST
    ListRoot   as gmlList ptr
    ListLength as Integer
    
    Declare SUB LoadLists()
End Type
   
Type gmlGAME
    FreChars   as Integer
    FailCount  as Integer
    ViewString as String
    RealString as String
    Chars(0 to 25)  as Integer
End Type

Sub gmlQUEST.LoadLists()
    Dim srcPATH as String
    Dim gmlFILE as String
    Dim gmlWORD as String
    Dim freFILE as Integer
    
    srcPATH = EXEPATH+"/"
    gmlFILE = Dir(srcPATH+"*.gml")
    
    Dim ListPos  as gmlLIST ptr
    Dim ListPosT as gmlLIST ptr
    
    Do
        If (gmlFILE <> "") Then
            freFILE = FreeFile
            Open srcPATH+gmlFILE for Input as #freFILE
                While not eof(freFILE)
                    gmlWORD=""
                    Line Input #freFILE, gmlWORD
                    gmlWORD=trim(gmlWORD)
                    If (gmlWORD <> "") Then
                        ListPosT = NEW gmlLIST
                        ListPosT -> gmlWORD = callocate(Len(gmlWORD)+1)
                        ListPosT -> gmlWLEN = Len(gmlWORD)
                        *ListPosT -> gmlWORD = gmlWORD
                    
                        If (ListPos) Then
                            ListPos -> NextWord = ListPosT
                            ListPos = ListPos -> NextWord
                            ListPosT = 0
                        Else
                            ListRoot = ListPosT
                            ListPos  = ListPosT
                            ListPosT = 0
                        End If
                    
                        ListLength += 1
                    End If
                Wend
            Close #freFile
            gmlFILE=""
        Else
            gmlFILE = Dir()
            If (gmlFILE = "") Then Exit Do
        End If
    Loop
End Sub

Sub GameMain()
    
    Dim gmlMAIN as gmlQUEST
    Dim ListPos as gmlLIST ptr
    Dim TempPos as gmlLIST ptr
    gmlMAIN.LoadLists()
    
    Dim ExitOption as Integer 
    Dim GKeyCode   as UShort
    
    Dim RNDQUEST as Integer
    Dim gmlRound as gmlGAME
    
    Dim c        as Integer
    Dim cc       as Integer
    
    Dim ViewStringPos as Integer
    
    Dim HangmanGRX as any ptr
    
    Do 'PreLoop
        
        ExitOption = 0
        
        gmlRound.FreChars   = 0
        gmlRound.FailCount  = 0
        gmlRound.ViewString = ""
        gmlRound.RealString = ""
        
        for l as Integer = 0 to 25
            gmlRound.Chars(l) = 0
        next l
        
        RNDQUEST = (rnd*(gmlMAIN.ListLength-1))
        ListPos  = gmlMAIN.ListRoot
        
        If (RNDQUEST) Then
            For l as Integer = 1 to RNDQUEST
                ListPos = ListPos -> NextWord
            Next l
        End If
        
        gmlRound.RealString = *ListPos -> gmlWORD
        gmlRound.ViewString = Space(Len(gmlRound.RealString))
        
        For l as Integer = 0 to Len(gmlRound.RealString)-1
            c = asc(ucase(chr(gmlRound.RealString[l])))
            If (c < 65) or (c > 90) Then 
                gmlRound.ViewString[l] = gmlRound.RealString[l]
            Else
                gmlRound.ViewString[l] = 95
                If (gmlRound.Chars(c-65) = 0) Then
                    gmlRound.FreChars   += 1
                    gmlRound.Chars(c-65) = 1
                End If
            End If
        Next l
        
        ViewStringPos = 225-(Len(gmlRound.RealString)*4)
        Do 'Game Loop
        
            Screenlock
                cls
                If (gmlRound.FailCount) Then
                    Select case gmlRound.FailCount
                        case 1
                            HangmanGRX = Hangman_1_GRX
                        case 2
                            HangmanGRX = Hangman_2_GRX
                        case 3
                            HangmanGRX = Hangman_3_GRX
                        case 4 
                            HangmanGRX = Hangman_4_GRX
                        case 5
                            HangmanGRX = Hangman_5_GRX
                    End Select
                    Put (150,10),HangmanGRX,trans
                    Imagedestroy(HangmanGRX)
                    HangmanGRX = 0
                End If
                
                'locate 1,1:?gmlRound.RealString,gmlRound.FreChars

                Draw String (ViewStringPos,175),gmlRound.ViewString
            Screenunlock
            
            GKeyCode = Getkey
            
            'esc/close exit (-1)
            If multikey(&h01) orelse ((GKeyCode > &hFF) andalso ( (GKeyCode shr 8) = 107 )) Then ExitOption = -1 : Exit Do
            
            'char
            cc = asc(ucase(chr(GKeyCode)))
            If ((cc > 64) and (cc < 91)) Then
                If (gmlRound.Chars(cc-65) = 1) Then 
                
                    gmlRound.Chars(cc-65) = 0
                    gmlRound.FreChars    -= 1
                
                    for l as integer = 0 to len(gmlRound.RealString)-1
                        c = asc(ucase(chr(gmlRound.RealString[l])))
                        If (c = cc) Then gmlRound.ViewString[l] = gmlRound.RealString[l]
                    next l
                Else
                    gmlRound.FailCount += 1
                End If
            End If
            
            'win/fail exit (1,2)
            If (gmlRound.FreChars  = 0) Then ExitOption = 1 : Exit Do 'Win
            If (gmlRound.FailCount = 6) Then ExitOption = 2 : Exit Do 'GameOver
            sleep 100
        Loop 'until ExitOption
        
        Select case ExitOption
            case -1 'end
                Exit Do
            case 1 'win
                Screenlock
                    cls
                    Draw String (180,175),"Yeeaaappiii :)"
                Screenunlock
                getkey    
            case 2 'fail
                Screenlock
                    cls
                    HangmanGRX = Hangman_6_GRX
                    put (150,10),HangmanGRX,trans
                    Imagedestroy(HangmanGRX)
                    Draw String (180,175),"OOOoooohhhh :("
                Screenunlock
                getkey    
        End select
            
    Loop 'until ExitOption = -1'multikey(&h01)
    
    'fremem
    ListPos = gmlMAIN.ListRoot
    Do
        If ListPos Then
            TempPos = ListPos -> NextWord
            deallocate ListPos -> gmlWORD
            ListPos -> gmlWLEN = 0
            Delete ListPos
            ListPos = TempPos
        Else 
            Exit Do
        End If
    Loop
End Sub

Screenres 450,200,32
GameMain()
    
